/**
 * Created by IntelliJ IDEA.
 * User: sbortman
 * Date: Jun 6, 2008
 * Time: 5:00:09 PM
 * To change this template use File | Settings | File Templates.
 */
class Geometry
{
  org.postgis.Geometry geom

  public String toString()
  {
    return geom.toString()
  }

  public static Geometry fromString(String s)
  {
    return new Geometry(geom: org.postgis.PGgeometry.geomFromString(s))
  }

  def getBounds()
  {
    def bounds = [
        minLon: geom?.getPoint(0).x,
        minLat: geom?.getPoint(0).y,
        maxLon: geom?.getPoint(0).x,
        maxLat: geom?.getPoint(0).y
    ]

    geom?.numPoints().times {index ->
      def pt = geom?.getPoint(index)

      if ( pt.x < bounds.minLon )
        bounds.minLon = pt.x
      if ( pt.x > bounds.maxLon )
        bounds.maxLon = pt.x
      if ( pt.y < bounds.minLat )
        bounds.minLat = pt.y
      if ( pt.y > bounds.maxLat )
        bounds.maxLat = pt.y
    }
    return bounds
  }

  public static def createPolygon(def minLon, def minLat, def maxLon, def maxLat)
  {
    return """POLYGON(
      (${minLon} ${minLat}, ${minLon} ${maxLat}, ${maxLon} ${maxLat}, ${maxLon} ${minLat}, ${minLon} ${minLat})
    )"""
  }

}